/*
 * Copyright (C) 2007 by Quentin Anciaux
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
 * for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; if not, write to the Free Software Foundation,
 * Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *	@author Quentin Anciaux
 */
package org.allcolor.yahp.cl.converter.swing;

import org.allcolor.yahp.cl.converter.swing.CSwingHtmlRenderer.CFormView;
import org.allcolor.yahp.cl.converter.swing.CSwingHtmlRenderer.CImageView;
import org.allcolor.yahp.cl.converter.swing.CSwingHtmlRenderer.CInlineView;
import org.allcolor.yahp.cl.converter.swing.CSwingHtmlRenderer.CView;
import org.allcolor.yahp.converter.IHtmlToPdfTransformer.PageSize;

import java.awt.Color;
import java.awt.Composite;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GraphicsConfiguration;
import java.awt.Image;
import java.awt.Paint;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import java.awt.Shape;
import java.awt.Stroke;
import java.awt.RenderingHints.Key;
import java.awt.font.FontRenderContext;
import java.awt.font.GlyphVector;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.awt.image.BufferedImageOp;
import java.awt.image.ImageObserver;
import java.awt.image.RenderedImage;
import java.awt.image.renderable.RenderableImage;

import java.text.AttributedCharacterIterator;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.swing.JTextPane;
import javax.swing.text.View;

/**
 * This class permits to paint a JTextPane in a Graphics2D object.
 * 
 * @author Quentin Anciaux
 * @version v0.98
 */
public class CTextPanePrinter {
	/** The panel to print */
	private JTextPane panel;

	/**
	 * DOCUMENT ME!
	 */
	private final List alreadyPainted = new ArrayList();

	/** current page Y offset */
	private double offsetY = 0;

	/**
	 * Creates a new CTextPanePrinter object.
	 * 
	 * @param pane
	 *            The JTextPane to print
	 */
	public CTextPanePrinter(final JTextPane pane) {
		this.panel = pane;
	} // end CTextPanePrinter()

	/**
	 * DOCUMENT ME!
	 * 
	 * @param pageFormat
	 *            DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public int countPages(final PageSize pageFormat) {
		int pageIndex = 0;
		while (true) {
			this.print(new Graphics2D() {

				public void setXORMode(final Color c1) {

				}

				public void setPaintMode() {

				}

				public void setFont(final Font font) {

				}

				public void setColor(final Color c) {

				}

				private Shape clip = null;

				public void setClip(final Shape clip) {
					this.clip = clip;
				}

				public void setClip(final int x, final int y, final int width, final int height) {
					this.clip = new Rectangle(x, y, width, height);
				}

				public FontMetrics getFontMetrics(final Font f) {
					return null;
				}

				public Font getFont() {
					return Font.decode(Font.DIALOG);
				}

				public Color getColor() {

					return null;
				}

				public Rectangle getClipBounds() {
					return this.clip != null ? this.clip.getBounds()
							: new Rectangle();
				}

				public Shape getClip() {
					return this.clip;
				}

				public void fillRoundRect(final int x, final int y, final int width, final int height,
						final int arcWidth, final int arcHeight) {

				}

				public void fillRect(final int x, final int y, final int width, final int height) {

				}

				public void fillPolygon(final int[] xPoints, final int[] yPoints,
						final int nPoints) {

				}

				public void fillOval(final int x, final int y, final int width, final int height) {

				}

				public void fillArc(final int x, final int y, final int width, final int height,
						final int startAngle, final int arcAngle) {

				}

				public void drawRoundRect(final int x, final int y, final int width, final int height,
						final int arcWidth, final int arcHeight) {

				}

				public void drawPolyline(final int[] xPoints, final int[] yPoints,
						final int nPoints) {

				}

				public void drawPolygon(final int[] xPoints, final int[] yPoints,
						final int nPoints) {

				}

				public void drawOval(final int x, final int y, final int width, final int height) {

				}

				public void drawLine(final int x1, final int y1, final int x2, final int y2) {

				}

				public boolean drawImage(final Image img, final int dx1, final int dy1, final int dx2,
						final int dy2, final int sx1, final int sy1, final int sx2, final int sy2,
						final ImageObserver observer) {

					return false;
				}

				public boolean drawImage(final Image img, final int dx1, final int dy1, final int dx2,
						final int dy2, final int sx1, final int sy1, final int sx2, final int sy2,
						final Color bgcolor, final ImageObserver observer) {

					return false;
				}

				public boolean drawImage(final Image img, final int x, final int y, final int width,
						final int height, final ImageObserver observer) {

					return false;
				}

				public boolean drawImage(final Image img, final int x, final int y, final int width,
						final int height, final Color bgcolor, final ImageObserver observer) {

					return false;
				}

				public boolean drawImage(final Image img, final int x, final int y,
						final ImageObserver observer) {

					return false;
				}

				public boolean drawImage(final Image img, final int x, final int y,
						final Color bgcolor, final ImageObserver observer) {

					return false;
				}

				public void drawArc(final int x, final int y, final int width, final int height,
						final int startAngle, final int arcAngle) {

				}

				public void dispose() {

				}

				public Graphics create() {

					return null;
				}

				public void copyArea(final int x, final int y, final int width, final int height,
						final int dx, final int dy) {

				}

				public void clipRect(final int x, final int y, final int width, final int height) {

				}

				public void clearRect(final int x, final int y, final int width, final int height) {

				}

				public void translate(final int x, final int y) {

				}

				public void translate(final double tx, final double ty) {

				}

				public void transform(final AffineTransform Tx) {

				}

				public void shear(final double shx, final double shy) {

				}

				public void setTransform(final AffineTransform Tx) {

				}

				public void setStroke(final Stroke s) {

				}

				public void setRenderingHints(final Map arg0) {

				}

				public void setRenderingHint(final Key hintKey, final Object hintValue) {

				}

				public void setPaint(final Paint paint) {

				}

				public void setComposite(final Composite comp) {

				}

				public void setBackground(final Color color) {

				}

				public void scale(final double sx, final double sy) {

				}

				public void rotate(final double theta) {

				}

				public void rotate(final double theta, final double x, final double y) {

				}

				public boolean hit(final Rectangle rect, final Shape s, final boolean onStroke) {

					return false;
				}

				public AffineTransform getTransform() {

					return null;
				}

				public Stroke getStroke() {

					return null;
				}

				public RenderingHints getRenderingHints() {

					return null;
				}

				public Object getRenderingHint(final Key hintKey) {

					return null;
				}

				public Paint getPaint() {

					return null;
				}

				public FontRenderContext getFontRenderContext() {

					return null;
				}

				public GraphicsConfiguration getDeviceConfiguration() {

					return null;
				}

				public Composite getComposite() {

					return null;
				}

				public Color getBackground() {

					return null;
				}

				public void fill(final Shape s) {

				}

				public void drawString(final String str, final int x, final int y) {

				}

				public void drawString(final String str, final float x, final float y) {

				}

				public void drawString(final AttributedCharacterIterator iterator,
						final int x, final int y) {

				}

				public void drawString(final AttributedCharacterIterator iterator,
						final float x, final float y) {

				}

				public void drawRenderedImage(final RenderedImage img,
						final AffineTransform xform) {

				}

				public void drawRenderableImage(final RenderableImage img,
						final AffineTransform xform) {

				}

				public boolean drawImage(final Image img, final AffineTransform xform,
						final ImageObserver obs) {

					return false;
				}

				public void drawImage(final BufferedImage img, final BufferedImageOp op,
						final int x, final int y) {

				}

				public void drawGlyphVector(final GlyphVector g, final float x, final float y) {

				}

				public void draw(final Shape s) {

				}

				public void clip(final Shape s) {

				}

				public void addRenderingHints(final Map arg0) {

				}

			}, pageFormat, pageIndex);
			if (!this.hasPaint) {
				this.alreadyPainted.clear();
				return pageIndex;
			}
			pageIndex++;
		} // end while
	} // end countPages()

	boolean hasPaint = false;

	/**
	 * Print the content of the JTextPane in a page
	 * 
	 * @param graphics2D
	 *            The Graphics2D object
	 * @param pageFormat
	 *            The page size
	 * @param pageIndex
	 *            The page to print.
	 */
	public void print(final Graphics2D graphics2D, final PageSize pageFormat,
			final int pageIndex) {
		this.hasPaint = false;
		double translate = -8.0;
		double scale = 1.0;
		final View rootView = this.panel.getUI().getRootView(this.panel);
		final int size[] = pageFormat.getSize();
		final int margin[] = pageFormat.getMargin();
		final int width = size[0] - (margin[0] + margin[1]);
		final int height = size[1] - (margin[2] + margin[3]);

		if (pageIndex == 0) {
			this.offsetY = (height + margin[3]) - 8;
		} // end if
		else {
			translate = this.offsetY - margin[3];
			this.offsetY = this.offsetY + height;
		} // end else

		if (this.panel.getMinimumSize().getWidth() > width) {
			scale = width / this.panel.getMinimumSize().getWidth();
		} // end if
		else if (this.panel.getPreferredSize().getWidth() < width) {
			scale = width / this.panel.getPreferredSize().getWidth();
		} // end else if

		graphics2D.setClip(margin[0], margin[3], width, height);
		graphics2D.translate(margin[0], -translate);
		graphics2D.scale(scale, scale);

		final double miny = this.offsetY - height;
		final Rectangle allocation = new Rectangle(0, (int) Math.round(margin[3]
				/ scale), (int) Math.round(width / scale), (int) Math
				.round(height / scale));
		Rectangle clipRectangle = new Rectangle(0, (int) Math.round(miny
				/ scale), (int) Math.round(width / scale), (int) Math
				.round(this.offsetY / scale)
				- (int) Math.round(miny / scale));
		this.paint(rootView, graphics2D, allocation);
		this.fakePaintView(graphics2D, allocation, rootView, clipRectangle, scale,
				miny);
		clipRectangle = new Rectangle(0, (int) Math.round(miny / scale),
				(int) Math.round(clipRectangle.width / scale), (int) Math
						.round(this.offsetY / scale)
						- (int) Math.round(miny / scale));
		graphics2D.setClip(clipRectangle);
		this.paintView(graphics2D, allocation, rootView, clipRectangle, scale, miny);
		graphics2D.setTransform(new AffineTransform(1.0, 0.0, 0.0, 1.0, 0.0,
				0.0));
	} // end print()

	public void printAll(final Graphics2D graphics2D, final PageSize pageFormat) {
		double translate = -8.0;
		double scale = 1.0;
		final View rootView = this.panel.getUI().getRootView(this.panel);
		final int size[] = pageFormat.getSize();
		final int margin[] = pageFormat.getMargin();
		final int width = size[0] - (margin[0] + margin[1]);
		final int height = size[1] - (margin[2] + margin[3]);

		this.offsetY = (height + margin[3]) - 8;

		if (this.panel.getMinimumSize().getWidth() > width) {
			scale = width / this.panel.getMinimumSize().getWidth();
		} // end if
		else if (this.panel.getPreferredSize().getWidth() < width) {
			scale = width / this.panel.getPreferredSize().getWidth();
		} // end else if

		graphics2D.setClip(margin[0], margin[3], width, height);
		graphics2D.translate(margin[0], -translate);
		graphics2D.scale(scale, scale);

		final double miny = this.offsetY - height;
		final Rectangle allocation = new Rectangle(0, (int) Math.round(margin[3]
				/ scale), (int) Math.round(width / scale), (int) Math
				.round(height / scale));
		Rectangle clipRectangle = new Rectangle(0, (int) Math.round(miny
				/ scale), (int) Math.round(width / scale), (int) Math
				.round(this.offsetY / scale)
				- (int) Math.round(miny / scale));
		this.paint(rootView, graphics2D, allocation);
		this.fakePaintView(graphics2D, allocation, rootView, clipRectangle, scale,
				miny);
		clipRectangle = new Rectangle(0, (int) Math.round(miny / scale),
				(int) Math.round(clipRectangle.width / scale), (int) Math
						.round(this.offsetY / scale)
						- (int) Math.round(miny / scale));
		graphics2D.setClip(clipRectangle);
		this.paintView(graphics2D, allocation, rootView, clipRectangle, scale, miny);
		graphics2D.setTransform(new AffineTransform(1.0, 0.0, 0.0, 1.0, 0.0,
				0.0));
	} // end print()

	/**
	 * Call the paint or realPaint depending on the element type
	 * 
	 * @param view
	 *            the view object to paint
	 * @param graphics2D
	 *            the graphics2D object
	 * @param allocation
	 *            the shape to paint in
	 */
	private void paint(final View view, final Graphics2D graphics2D,
			final Shape allocation) {
		try {
			if (view.getClass() == CInlineView.class) {
				((CInlineView) view).realPaint(graphics2D, allocation);
			} // end if
			else if (view.getClass() == CImageView.class) {
				((CImageView) view).realPaint(graphics2D, allocation);
			} // end else if
			else if (view.getClass() == CFormView.class) {
				((CFormView) view).realPaint(graphics2D, allocation);
			} // end else if
			else if (view.getClass() == CView.class) {
				((CView) view).realPaint(graphics2D, allocation);
			} // end else if
			else {
				view.paint(graphics2D, allocation);
			} // end else
		} catch (final Exception ignore) {
		}
	} // end paint()

	private void fakePaintView(final Graphics2D graphics2D,
			final Shape allocation, final View view,
			final Rectangle clipRectangle, final double scale, final double miny) {
		Shape childAllocation;
		View childView;
		if (view.getViewCount() > 0) {
			if (view != this.panel.getUI().getRootView(this.panel)) {
				if ((allocation.getBounds().getMaxY() * scale) > miny) {
					if (((allocation.getBounds().getHeight() * scale) > (clipRectangle
							.getHeight() * scale))
							&& (allocation.intersects(clipRectangle))) {
					} else if ((allocation.getBounds().getY() * scale) > miny) {
						if ((allocation.getBounds().getMaxY() * scale) < this.offsetY) {
						} else {
							if ((allocation.getBounds().getMaxY() * scale - allocation
									.getBounds().getY()
									* scale) <= ((this.offsetY - miny) / 5)) {
								if ((allocation.getBounds().getY() * scale) < this.offsetY) {
									this.offsetY = (allocation.getBounds().getY() * scale) - 2;
								} // end if
							}
						}
					}
				}
			}
			for (int i = 0; i < view.getViewCount(); i++) {

				childAllocation = view.getChildAllocation(i, allocation);

				if (childAllocation != null) {
					childView = view.getView(i);

					this.fakePaintView(graphics2D, childAllocation, childView,
							clipRectangle, scale, miny);
				} // end if
			} // end for
		} // end if
		else {
			// I
			if ((allocation.getBounds().getMaxY() * scale) > miny) {
				if (((allocation.getBounds().getHeight() * scale) > (clipRectangle
						.getHeight() * scale))
						&& (allocation.intersects(clipRectangle))) {
				} // end if
				else {
					if ((allocation.getBounds().getY() * scale) > miny) {
						if ((allocation.getBounds().getMaxY() * scale) < this.offsetY) {
						} // end if
						else {
							if ((allocation.getBounds().getY() * scale) < this.offsetY) {
								this.offsetY = (allocation.getBounds().getY() * scale) - 2;
							} // end if
						} // end else
					} // end if
				} // end else
			} // end if
		} // end else
	} // end paintView()

	/**
	 * Paint the views recursively
	 * 
	 * @param graphics2D
	 *            The graphics2D object
	 * @param allocation
	 *            shape to paint in
	 * @param view
	 *            view to paint
	 * @param clipRectangle
	 *            DOCUMENT ME!
	 * @param scale
	 *            DOCUMENT ME!
	 * @param miny
	 *            DOCUMENT ME!
	 */
	private void paintView(final Graphics2D graphics2D, final Shape allocation,
			final View view, final Rectangle clipRectangle, final double scale,
			final double miny) {
		Shape childAllocation;
		View childView;
		if (view.getViewCount() > 0) {
			if (view != this.panel.getUI().getRootView(this.panel)) {
				if ((allocation.getBounds().getMaxY() * scale) > miny) {
					if (((allocation.getBounds().getHeight() * scale) > (clipRectangle
							.getHeight() * scale))
							&& (allocation.intersects(clipRectangle))) {
						// paint(view, graphics2D, allocation);
					} else if ((allocation.getBounds().getY() * scale) > miny) {
						if ((allocation.getBounds().getMaxY() * scale) < this.offsetY) {
							this.paint(view, graphics2D, allocation);
						} else {
							if ((allocation.getBounds().getMaxY() * scale - allocation
									.getBounds().getY()
									* scale) <= ((this.offsetY - miny) / 5)) {
								if ((allocation.getBounds().getY() * scale) < this.offsetY) {
									this.offsetY = (allocation.getBounds().getY() * scale) - 2;
								} // end if
							}
						}
					}
				}
			}
			for (int i = 0; i < view.getViewCount(); i++) {

				childAllocation = view.getChildAllocation(i, allocation);

				if (childAllocation != null) {
					childView = view.getView(i);

					this.paintView(graphics2D, childAllocation, childView,
							clipRectangle, scale, miny);
				} // end if
			} // end for
		} // end if
		else {
			// I
			if ((allocation.getBounds().getMaxY() * scale) > miny) {
				if (((allocation.getBounds().getHeight() * scale) > (clipRectangle
						.getHeight() * scale))
						&& (allocation.intersects(clipRectangle))) {
					// paint(view, graphics2D, allocation);
				} // end if
				else {
					if ((allocation.getBounds().getY() * scale) > miny) {
						if ((allocation.getBounds().getMaxY() * scale) < this.offsetY) {
							if (!this.alreadyPainted.contains(view)) {
								this.hasPaint = true;
								this.paint(view, graphics2D, allocation);
								this.alreadyPainted.add(view);
							} // end if
						} // end if
						else {
							if ((allocation.getBounds().getY() * scale) < this.offsetY) {
								this.offsetY = (allocation.getBounds().getY() * scale) - 2;
							} // end if
						} // end else
					} // end if
				} // end else
			} // end if
		} // end else
	} // end paintView()
} // end CTextPanePrinter
