package org.allcolor.yahp.cl.converter.swing;

import java.awt.Color;

import javax.swing.text.AttributeSet;
import javax.swing.text.View;
import javax.swing.text.html.CSS;

public class CSwingHtmlBorder {
	public static final int dotted = 0;
	public static final int dashed = 1;
	public static final int solid = 2;
	public static final int doubleBorder = 3;
	public static final int groove = 4;
	public static final int ridge = 5;
	public static final int inset = 6;
	public static final int outset = 7;
	
	private int leftBorderWidth = 0;
	private int rightBorderWidth = 0;
	private int topBorderWidth = 0;
	private int bottomBorderWidth = 0;
	private Color leftBorderColor = Color.BLACK;
	private Color rightBorderColor = Color.BLACK;
	private Color topBorderColor = Color.BLACK;
	private Color bottomBorderColor = Color.BLACK;
	private int leftBorderType = solid;
	private int rightBorderType = solid;
	private int topBorderType = solid;
	private int bottomBorderType = solid;
	
	
	public int getBottomBorderType() {
		return bottomBorderType;
	}

	public int getRightBorderType() {
		return rightBorderType;
	}

	public int getTopBorderType() {
		return topBorderType;
	}

	public int getLeftBorderType() {
		return leftBorderType;
	}

	private CSwingHtmlBorder() {}
	
	public Color getBottomBorderColor() {
		return bottomBorderColor;
	}

	public int getBottomBorderWidth() {
		return bottomBorderWidth;
	}

	public Color getLeftBorderColor() {
		return leftBorderColor;
	}

	public int getLeftBorderWidth() {
		return leftBorderWidth;
	}

	public Color getRightBorderColor() {
		return rightBorderColor;
	}

	public int getRightBorderWidth() {
		return rightBorderWidth;
	}

	public Color getTopBorderColor() {
		return topBorderColor;
	}

	public int getTopBorderWidth() {
		return topBorderWidth;
	}

	private static String getBorder(View view,AttributeSet set,String name,boolean inherit) {
		try {
			String border = (String)set.getAttribute(CSS.getAttribute(name));
			if (border != null) {
				if (!inherit && view.getParent() != null) {
					set = view.getParent().getElement().getAttributes();
					String pborder = (String)set.getAttribute(CSS.getAttribute(name));
					if (border.equals(pborder))
						return null;
				}
				return border;
			}
		}
		catch (Exception ignore){
		}
		return null;
	}
	
	public static CSwingHtmlBorder getBorder(View view,boolean inherit) {
		AttributeSet set = view.getElement().getAttributes();
		CSwingHtmlBorder b = new CSwingHtmlBorder();
		String border = getBorder(view,set,"border",inherit);
		if (border != null) {
			String [] props = border.split("\\s");
			for (int i=0;i<props.length;i++) {
				if (props[i].endsWith("px")) {
					// got length
					int len = 0;
					try {
						len = Integer.parseInt(props[i].substring(0,props[i].length()-2));
					}
					catch (Exception ignore){}
					b.bottomBorderWidth = len;
					b.topBorderWidth = len;
					b.leftBorderWidth = len;
					b.rightBorderWidth = len;
					continue;
				}
				if ("dotted".equalsIgnoreCase(props[i])) {
					b.bottomBorderType = dotted;
					b.topBorderType = dotted;
					b.leftBorderType = dotted;
					b.rightBorderType = dotted;
					continue;
				}
				if ("dashed".equalsIgnoreCase(props[i])) {
					b.bottomBorderType = dashed;
					b.topBorderType = dashed;
					b.leftBorderType = dashed;
					b.rightBorderType = dashed;
					continue;
				}
				if ("double".equalsIgnoreCase(props[i])) {
					b.bottomBorderType = doubleBorder;
					b.topBorderType = doubleBorder;
					b.leftBorderType = doubleBorder;
					b.rightBorderType = doubleBorder;
					continue;
				}
				if ("groove".equalsIgnoreCase(props[i])) {
					b.bottomBorderType = groove;
					b.topBorderType = groove;
					b.leftBorderType = groove;
					b.rightBorderType = groove;
					continue;
				}
				if ("inset".equalsIgnoreCase(props[i])) {
					b.bottomBorderType = inset;
					b.topBorderType = inset;
					b.leftBorderType = inset;
					b.rightBorderType = inset;
					continue;
				}
				if ("outset".equalsIgnoreCase(props[i])) {
					b.bottomBorderType = outset;
					b.topBorderType = outset;
					b.leftBorderType = outset;
					b.rightBorderType = outset;
					continue;
				}
				if ("ridge".equalsIgnoreCase(props[i])) {
					b.bottomBorderType = ridge;
					b.topBorderType = ridge;
					b.leftBorderType = ridge;
					b.rightBorderType = ridge;
					continue;
				}
				if ("solid".equalsIgnoreCase(props[i])) {
					b.bottomBorderType = solid;
					b.topBorderType = solid;
					b.leftBorderType = solid;
					b.rightBorderType = solid;
					continue;
				}
				b.bottomBorderColor = getColor(props[i]);
				b.topBorderColor = getColor(props[i]);
				b.leftBorderColor = getColor(props[i]);
				b.rightBorderColor = getColor(props[i]);
			}
		}
		String bottomBorder = getBorder(view,set,"border-bottom",inherit);
		if (bottomBorder != null) {
			String [] props = bottomBorder.split("\\s");
			for (int i=0;i<props.length;i++) {
				if (props[i].endsWith("px")) {
					// got length
					int len = 0;
					try {
						len = Integer.parseInt(props[i].substring(0,props[i].length()-2));
					}
					catch (Exception ignore){}
					b.bottomBorderWidth = len;
					continue;
				}
				if ("dotted".equalsIgnoreCase(props[i])) {
					b.bottomBorderType = dotted;
					continue;
				}
				if ("dashed".equalsIgnoreCase(props[i])) {
					b.bottomBorderType = dashed;
					continue;
				}
				if ("double".equalsIgnoreCase(props[i])) {
					b.bottomBorderType = doubleBorder;
					continue;
				}
				if ("groove".equalsIgnoreCase(props[i])) {
					b.bottomBorderType = groove;
					continue;
				}
				if ("inset".equalsIgnoreCase(props[i])) {
					b.bottomBorderType = inset;
					continue;
				}
				if ("outset".equalsIgnoreCase(props[i])) {
					b.bottomBorderType = outset;
					continue;
				}
				if ("ridge".equalsIgnoreCase(props[i])) {
					b.bottomBorderType = ridge;
					continue;
				}
				if ("solid".equalsIgnoreCase(props[i])) {
					b.bottomBorderType = solid;
					continue;
				}
				b.bottomBorderColor = getColor(props[i]);
			}
		}
		String topBorder = getBorder(view,set,"border-top",inherit);
		if (topBorder != null) {
			String [] props = topBorder.split("\\s");
			for (int i=0;i<props.length;i++) {
				if (props[i].endsWith("px")) {
					// got length
					int len = 0;
					try {
						len = Integer.parseInt(props[i].substring(0,props[i].length()-2));
					}
					catch (Exception ignore){}
					b.topBorderWidth = len;
					continue;
				}
				if ("dotted".equalsIgnoreCase(props[i])) {
					b.topBorderType = dotted;
					continue;
				}
				if ("dashed".equalsIgnoreCase(props[i])) {
					b.topBorderType = dashed;
					continue;
				}
				if ("double".equalsIgnoreCase(props[i])) {
					b.topBorderType = doubleBorder;
					continue;
				}
				if ("groove".equalsIgnoreCase(props[i])) {
					b.topBorderType = groove;
					continue;
				}
				if ("inset".equalsIgnoreCase(props[i])) {
					b.topBorderType = inset;
					continue;
				}
				if ("outset".equalsIgnoreCase(props[i])) {
					b.topBorderType = outset;
					continue;
				}
				if ("ridge".equalsIgnoreCase(props[i])) {
					b.topBorderType = ridge;
					continue;
				}
				if ("solid".equalsIgnoreCase(props[i])) {
					b.topBorderType = solid;
					continue;
				}
				b.topBorderColor = getColor(props[i]);
			}
		}
		String leftBorder = getBorder(view,set,"border-left",inherit);
		if (leftBorder != null) {
			String [] props = leftBorder.split("\\s");
			for (int i=0;i<props.length;i++) {
				if (props[i].endsWith("px")) {
					// got length
					int len = 0;
					try {
						len = Integer.parseInt(props[i].substring(0,props[i].length()-2));
					}
					catch (Exception ignore){}
					b.leftBorderWidth = len;
					continue;
				}
				if ("dotted".equalsIgnoreCase(props[i])) {
					b.leftBorderType = dotted;
					continue;
				}
				if ("dashed".equalsIgnoreCase(props[i])) {
					b.leftBorderType = dashed;
					continue;
				}
				if ("double".equalsIgnoreCase(props[i])) {
					b.leftBorderType = doubleBorder;
					continue;
				}
				if ("groove".equalsIgnoreCase(props[i])) {
					b.leftBorderType = groove;
					continue;
				}
				if ("inset".equalsIgnoreCase(props[i])) {
					b.leftBorderType = inset;
					continue;
				}
				if ("outset".equalsIgnoreCase(props[i])) {
					b.leftBorderType = outset;
					continue;
				}
				if ("ridge".equalsIgnoreCase(props[i])) {
					b.leftBorderType = ridge;
					continue;
				}
				if ("solid".equalsIgnoreCase(props[i])) {
					b.leftBorderType = solid;
					continue;
				}
				b.leftBorderColor = getColor(props[i]);
			}
		}
		String rightBorder = getBorder(view,set,"border-right",inherit);
		if (rightBorder != null) {
			String [] props = rightBorder.split("\\s");
			for (int i=0;i<props.length;i++) {
				if (props[i].endsWith("px")) {
					// got length
					int len = 0;
					try {
						len = Integer.parseInt(props[i].substring(0,props[i].length()-2));
					}
					catch (Exception ignore){}
					b.rightBorderWidth = len;
					continue;
				}
				if ("dotted".equalsIgnoreCase(props[i])) {
					b.rightBorderType = dotted;
					continue;
				}
				if ("dashed".equalsIgnoreCase(props[i])) {
					b.rightBorderType = dashed;
					continue;
				}
				if ("double".equalsIgnoreCase(props[i])) {
					b.rightBorderType = doubleBorder;
					continue;
				}
				if ("groove".equalsIgnoreCase(props[i])) {
					b.rightBorderType = groove;
					continue;
				}
				if ("inset".equalsIgnoreCase(props[i])) {
					b.rightBorderType = inset;
					continue;
				}
				if ("outset".equalsIgnoreCase(props[i])) {
					b.rightBorderType = outset;
					continue;
				}
				if ("ridge".equalsIgnoreCase(props[i])) {
					b.rightBorderType = ridge;
					continue;
				}
				if ("solid".equalsIgnoreCase(props[i])) {
					b.rightBorderType = solid;
					continue;
				}
				b.rightBorderColor = getColor(props[i]);
			}
		}
		String bottomBorderWidth = getBorder(view,set,"border-bottom-width",inherit);
		if (bottomBorderWidth != null) {
			if (bottomBorderWidth.endsWith("px")) {
				// got length
				int len = 0;
				try {
					len = Integer.parseInt(bottomBorderWidth.substring(0,bottomBorderWidth.length()-2));
				}
				catch (Exception ignore){}
				b.bottomBorderWidth = len;
			}
		}
		String topBorderWidth = getBorder(view,set,"border-top-width",inherit);
		if (topBorderWidth != null) {
			if (topBorderWidth.endsWith("px")) {
				// got length
				int len = 0;
				try {
					len = Integer.parseInt(topBorderWidth.substring(0,topBorderWidth.length()-2));
				}
				catch (Exception ignore){}
				b.topBorderWidth = len;
			}
		}
		String leftBorderWidth = getBorder(view,set,"border-left-width",inherit);
		if (leftBorderWidth != null) {
			if (leftBorderWidth.endsWith("px")) {
				// got length
				int len = 0;
				try {
					len = Integer.parseInt(leftBorderWidth.substring(0,leftBorderWidth.length()-2));
				}
				catch (Exception ignore){}
				b.leftBorderWidth = len;
			}
		}
		String rightBorderWidth = getBorder(view,set,"border-right-width",inherit);
		if (rightBorderWidth != null) {
			if (rightBorderWidth.endsWith("px")) {
				// got length
				int len = 0;
				try {
					len = Integer.parseInt(rightBorderWidth.substring(0,rightBorderWidth.length()-2));
				}
				catch (Exception ignore){}
				b.rightBorderWidth = len;
			}
		}
		return b;
	}
	
	private static Color getColor(String color) {
		if ("red".equalsIgnoreCase(color)) {
			return Color.RED;
		}
		if ("black".equalsIgnoreCase(color)) {
			return Color.BLACK;
		}
		if ("green".equalsIgnoreCase(color)) {
			return Color.GREEN;
		}
		if ("white".equalsIgnoreCase(color)) {
			return Color.WHITE;
		}
		if ("blue".equalsIgnoreCase(color)) {
			return Color.BLUE;
		}
		if ("cyan".equalsIgnoreCase(color)) {
			return Color.CYAN;
		}
		if ("dark-gray".equalsIgnoreCase(color)) {
			return Color.DARK_GRAY;
		}
		if ("gray".equalsIgnoreCase(color)) {
			return Color.GRAY;
		}
		if ("light-gray".equalsIgnoreCase(color)) {
			return Color.LIGHT_GRAY;
		}
		if ("magenta".equalsIgnoreCase(color)) {
			return Color.MAGENTA;
		}
		if ("orange".equalsIgnoreCase(color)) {
			return Color.ORANGE;
		}
		if ("pink".equalsIgnoreCase(color)) {
			return Color.PINK;
		}
		if ("yellow".equalsIgnoreCase(color)) {
			return Color.YELLOW;
		}
		try {
			return Color.decode(color.substring(1));
		}
		catch (Exception ignore){}
		return Color.BLACK;
	}
}
